//+------------------------------------------------------------------+
//|                               Forex Generator version 4.4        |
//|                                 Copyright (C) 2011, Etasoft Inc. |
//|                                    http://www.forexgenerator.com |
//+------------------------------------------------------------------+
// Keywords: indicator developer, Forex indicator builder, create forex indicator, MT4


#property copyright "Your copyright"
#property link "Link to your website"
#property indicator_separate_window
#property indicator_buffers 3

#property indicator_color1 Red
#property indicator_width1 2
#property indicator_color2 Blue
#property indicator_width2 2
#property indicator_color3 Green
#property indicator_width3 2


extern bool showTotal = true;
extern bool showSmall = true;
extern bool showLarge = true;
extern int avgPeriod = 30;  // how many bars back to average the rolling separation volume
// exported variables


// local variables
//string LF = "\n";  // use this in custom or utility blocks where you need line feeds
//int ObjCount = 0;  // count of all objects created on the chart, allows creation of objects with unique names
//int current = 0; // variable points to current bar

double Buffer1[];
double Buffer2[];
double Buffer3[];
double sum = 0;
double sumS = 0;
double sumL = 0;
double totalVol;
double avgVol;
//int numBars;




//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
    //ObjectsDeleteAll();      // clear the chart
    IndicatorShortName("EVIndicator2011v6Noam");
    //IndicatorDigits(Digits);
    IndicatorBuffers(3);  
    SetIndexBuffer(0, Buffer1);
    SetIndexStyle(0, DRAW_LINE);
    SetIndexBuffer(1, Buffer2);
    SetIndexStyle(1, DRAW_LINE);
    SetIndexBuffer(2, Buffer3);
    SetIndexStyle(2, DRAW_LINE);
    
    
    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
{
    ObjectsDeleteAll();
    
    
    return(0);
}

//+------------------------------------------------------------------+
//| Custom indicator start function                                  |
//+------------------------------------------------------------------+
int start()
{
    int i, j, limit;
    double tmp, tmp2;
    int counted_bars=IndicatorCounted();
    static int counted_bars_last=0;
    
    
    if(counted_bars < 0) return(-1);
    if(counted_bars > 0) counted_bars--;
    
    limit = Bars  - counted_bars -1;
 
    // main calculation loop
    
    for(i = limit; i >= 1; i--)
    {
      totalVol = 0;
      for (j = 0; j < avgPeriod; j++) {  // find the EV sum
	     tmp2 = ((MathMax(High[i+j], Close[i+j+1]))-(MathMin(Low[i+j], Close[i+j+1])))+Point;
      	if (tmp2 > 0.00001 || tmp2 < -0.00001)  // filter out extremes
            tmp = (((Close[i+j]-Close[i+j+1])+Point)/tmp2)*Volume[i+j];
     	   else
            tmp = 0;
      	totalVol += MathAbs(tmp);
      }
      avgVol = totalVol/avgPeriod;   // find the average EV (separation volume)
      if ((counted_bars == 0 && counted_bars_last == 0) || (counted_bars_last > 0 && counted_bars != counted_bars_last))
         ChartLine3(i);
      counted_bars_last = counted_bars;
    }
   
    return(0);
}


void ChartLine3(int i)
{
    double tmp3,tmp4;

    tmp3 = ((MathMax(High[i], Close[i+1]))-(MathMin(Low[i], Close[i+1])))+Point;
    if (tmp3 > 0.00001 || tmp3 < -0.00001)
      tmp4 = (((Close[i]-Close[i+1])+Point)/tmp3)*Volume[i];
    else
      tmp4 = 0;
    sum += tmp4;
    if (MathAbs(tmp4) < avgVol)
      sumS += tmp4;
    else
      sumL += tmp4;
	if (showTotal)
    Buffer1[i] = sum;
   if (showSmall)
    Buffer2[i] = sumS;
   if (showLarge)
    Buffer3[i] = sumL;
    
    return;
}



